# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union
from pydantic import BaseModel, StrictBytes, StrictInt, StrictStr
from pydantic import Field
from antimatter.client.models.hook_invocation import HookInvocation
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CapsuleOpenRequest(BaseModel):
    """
    A request to open (decrypt) a capsule 
    """ # noqa: E501
    encrypted_dek: Union[StrictBytes, StrictStr] = Field(description="a CBOR encoded encrypted decryption key for the capsule", alias="encryptedDek")
    key_id: StrictInt = Field(description="Encryption key ID", alias="keyID")
    invoked_hooks: List[HookInvocation] = Field(description="A list of hooks that have been invoked on the capsule data prior to sealing, along with their versions. ", alias="invokedHooks")
    __properties: ClassVar[List[str]] = ["encryptedDek", "keyID", "invokedHooks"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CapsuleOpenRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in invoked_hooks (list)
        _items = []
        if self.invoked_hooks:
            for _item in self.invoked_hooks:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invokedHooks'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CapsuleOpenRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "encryptedDek": obj.get("encryptedDek"),
            "keyID": obj.get("keyID"),
            "invokedHooks": [HookInvocation.from_dict(_item) for _item in obj.get("invokedHooks")] if obj.get("invokedHooks") is not None else None
        })
        return _obj


