# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union
from pydantic import BaseModel, StrictBytes, StrictStr
from pydantic import Field
from typing_extensions import Annotated
from antimatter.client.models.capsule_open_response_read_context_configuration import CapsuleOpenResponseReadContextConfiguration
from antimatter.client.models.tag import Tag
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CapsuleOpenResponse(BaseModel):
    """
    Contains key material for a capsule 
    """ # noqa: E501
    decryption_key: Union[StrictBytes, StrictStr] = Field(description="a CBOR encoded decryption key for the capsule", alias="decryptionKey")
    read_context_configuration: CapsuleOpenResponseReadContextConfiguration = Field(alias="readContextConfiguration")
    open_token: Annotated[str, Field(min_length=64, strict=True)] = Field(description="A token used to tie requests together when creating and reading capsules.", alias="openToken")
    capsule_tags: List[Tag] = Field(description="the tags for this capsule", alias="capsuleTags")
    __properties: ClassVar[List[str]] = ["decryptionKey", "readContextConfiguration", "openToken", "capsuleTags"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CapsuleOpenResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of read_context_configuration
        if self.read_context_configuration:
            _dict['readContextConfiguration'] = self.read_context_configuration.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in capsule_tags (list)
        _items = []
        if self.capsule_tags:
            for _item in self.capsule_tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['capsuleTags'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CapsuleOpenResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "decryptionKey": obj.get("decryptionKey"),
            "readContextConfiguration": CapsuleOpenResponseReadContextConfiguration.from_dict(obj.get("readContextConfiguration")) if obj.get("readContextConfiguration") is not None else None,
            "openToken": obj.get("openToken"),
            "capsuleTags": [Tag.from_dict(_item) for _item in obj.get("capsuleTags")] if obj.get("capsuleTags") is not None else None
        })
        return _obj


