# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictInt
from pydantic import Field
from typing_extensions import Annotated
from antimatter.client.models.tag import Tag
from antimatter.client.models.tag_summary import TagSummary
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CapsuleSealRequest(BaseModel):
    """
    Information applied when sealing a capsule (marking it as complete) 
    """ # noqa: E501
    capsule_tags: List[Tag] = Field(alias="capsuleTags")
    span_tags: TagSummary = Field(alias="spanTags")
    size: StrictInt = Field(description="how big this capsule is")
    create_token: Annotated[str, Field(min_length=64, strict=True)] = Field(description="A token used to tie requests together when creating and reading capsules.", alias="createToken")
    __properties: ClassVar[List[str]] = ["capsuleTags", "spanTags", "size", "createToken"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CapsuleSealRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in capsule_tags (list)
        _items = []
        if self.capsule_tags:
            for _item in self.capsule_tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['capsuleTags'] = _items
        # override the default output from pydantic by calling `to_dict()` of span_tags
        if self.span_tags:
            _dict['spanTags'] = self.span_tags.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CapsuleSealRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "capsuleTags": [Tag.from_dict(_item) for _item in obj.get("capsuleTags")] if obj.get("capsuleTags") is not None else None,
            "spanTags": TagSummary.from_dict(obj.get("spanTags")) if obj.get("spanTags") is not None else None,
            "size": obj.get("size"),
            "createToken": obj.get("createToken")
        })
        return _obj


