# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from typing_extensions import Annotated
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DomainControlLogEntry(BaseModel):
    """
    Results for a domain control log query 
    """ # noqa: E501
    id: Annotated[str, Field(strict=True)] = Field(description="A globally unique chronological identifier for a log record. If you sort by this identifier, your logs will be in chronological order ")
    time: datetime = Field(description="the time of an operation, in UTC")
    session: Annotated[str, Field(strict=True)] = Field(description="An identifier for an authentication session")
    url: StrictStr
    summary: Annotated[str, Field(strict=True, max_length=100)]
    description: Dict[str, StrictStr]
    __properties: ClassVar[List[str]] = ["id", "time", "session", "url", "summary", "description"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[0-9a-f]{32}", value):
            raise ValueError(r"must validate the regular expression /^[0-9a-f]{32}/")
        return value

    @field_validator('session')
    def session_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^sn-[a-z0-9]{22}$", value):
            raise ValueError(r"must validate the regular expression /^sn-[a-z0-9]{22}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DomainControlLogEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DomainControlLogEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "time": obj.get("time"),
            "session": obj.get("session"),
            "url": obj.get("url"),
            "summary": obj.get("summary"),
            "description": obj.get("description")
        })
        return _obj


