# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictBool
from pydantic import Field
from antimatter.client.models.domain_control_log_entry import DomainControlLogEntry
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DomainControlLogResults(BaseModel):
    """
    The results for a query of the capsule access log 
    """ # noqa: E501
    results: List[DomainControlLogEntry]
    has_more: StrictBool = Field(description="if true, there are more results. Query again with start_from_id equal to  the last result's ID to get more results. ")
    __properties: ClassVar[List[str]] = ["results", "has_more"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DomainControlLogResults from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in results (list)
        _items = []
        if self.results:
            for _item in self.results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DomainControlLogResults from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "results": [DomainControlLogEntry.from_dict(_item) for _item in obj.get("results")] if obj.get("results") is not None else None,
            "has_more": obj.get("has_more")
        })
        return _obj


