# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from antimatter.client.models.new_access_log_entry_read_info import NewAccessLogEntryReadInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class NewAccessLogEntry(BaseModel):
    """
    An individual capsule data-plane log entry, in the form required when inserting a  new record 
    """ # noqa: E501
    operation: StrictStr
    location: Optional[StrictStr] = Field(default=None, description="the location URL that this capsule resided in during the operation, if known ")
    read_info: NewAccessLogEntryReadInfo = Field(alias="readInfo")
    __properties: ClassVar[List[str]] = ["operation", "location", "readInfo"]

    @field_validator('operation')
    def operation_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('read'):
            raise ValueError("must be one of enum values ('read')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of NewAccessLogEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of read_info
        if self.read_info:
            _dict['readInfo'] = self.read_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of NewAccessLogEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "operation": obj.get("operation"),
            "location": obj.get("location"),
            "readInfo": NewAccessLogEntryReadInfo.from_dict(obj.get("readInfo")) if obj.get("readInfo") is not None else None
        })
        return _obj


