# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, field_validator
from antimatter.client.models.json_patch_request_add import JSONPatchRequestAdd
from antimatter.client.models.json_patch_request_copy import JSONPatchRequestCopy
from antimatter.client.models.json_patch_request_move import JSONPatchRequestMove
from antimatter.client.models.json_patch_request_remove import JSONPatchRequestRemove
from antimatter.client.models.json_patch_request_replace import JSONPatchRequestReplace
from antimatter.client.models.json_patch_request_tst import JSONPatchRequestTst
from typing import Union, Any, List, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal
from pydantic import StrictStr, Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

PATCHREQUESTINNER_ONE_OF_SCHEMAS = ["JSONPatchRequestAdd", "JSONPatchRequestCopy", "JSONPatchRequestMove", "JSONPatchRequestRemove", "JSONPatchRequestReplace", "JSONPatchRequestTst"]

class PatchRequestInner(BaseModel):
    """
    PatchRequestInner
    """
    # data type: JSONPatchRequestAdd
    oneof_schema_1_validator: Optional[JSONPatchRequestAdd] = None
    # data type: JSONPatchRequestReplace
    oneof_schema_2_validator: Optional[JSONPatchRequestReplace] = None
    # data type: JSONPatchRequestTst
    oneof_schema_3_validator: Optional[JSONPatchRequestTst] = None
    # data type: JSONPatchRequestRemove
    oneof_schema_4_validator: Optional[JSONPatchRequestRemove] = None
    # data type: JSONPatchRequestMove
    oneof_schema_5_validator: Optional[JSONPatchRequestMove] = None
    # data type: JSONPatchRequestCopy
    oneof_schema_6_validator: Optional[JSONPatchRequestCopy] = None
    actual_instance: Optional[Union[JSONPatchRequestAdd, JSONPatchRequestCopy, JSONPatchRequestMove, JSONPatchRequestRemove, JSONPatchRequestReplace, JSONPatchRequestTst]] = None
    one_of_schemas: List[str] = Literal["JSONPatchRequestAdd", "JSONPatchRequestCopy", "JSONPatchRequestMove", "JSONPatchRequestRemove", "JSONPatchRequestReplace", "JSONPatchRequestTst"]

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PatchRequestInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: JSONPatchRequestAdd
        if not isinstance(v, JSONPatchRequestAdd):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JSONPatchRequestAdd`")
        else:
            match += 1
        # validate data type: JSONPatchRequestReplace
        if not isinstance(v, JSONPatchRequestReplace):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JSONPatchRequestReplace`")
        else:
            match += 1
        # validate data type: JSONPatchRequestTst
        if not isinstance(v, JSONPatchRequestTst):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JSONPatchRequestTst`")
        else:
            match += 1
        # validate data type: JSONPatchRequestRemove
        if not isinstance(v, JSONPatchRequestRemove):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JSONPatchRequestRemove`")
        else:
            match += 1
        # validate data type: JSONPatchRequestMove
        if not isinstance(v, JSONPatchRequestMove):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JSONPatchRequestMove`")
        else:
            match += 1
        # validate data type: JSONPatchRequestCopy
        if not isinstance(v, JSONPatchRequestCopy):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JSONPatchRequestCopy`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PatchRequestInner with oneOf schemas: JSONPatchRequestAdd, JSONPatchRequestCopy, JSONPatchRequestMove, JSONPatchRequestRemove, JSONPatchRequestReplace, JSONPatchRequestTst. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PatchRequestInner with oneOf schemas: JSONPatchRequestAdd, JSONPatchRequestCopy, JSONPatchRequestMove, JSONPatchRequestRemove, JSONPatchRequestReplace, JSONPatchRequestTst. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into JSONPatchRequestAdd
        try:
            instance.actual_instance = JSONPatchRequestAdd.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JSONPatchRequestReplace
        try:
            instance.actual_instance = JSONPatchRequestReplace.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JSONPatchRequestTst
        try:
            instance.actual_instance = JSONPatchRequestTst.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JSONPatchRequestRemove
        try:
            instance.actual_instance = JSONPatchRequestRemove.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JSONPatchRequestMove
        try:
            instance.actual_instance = JSONPatchRequestMove.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JSONPatchRequestCopy
        try:
            instance.actual_instance = JSONPatchRequestCopy.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PatchRequestInner with oneOf schemas: JSONPatchRequestAdd, JSONPatchRequestCopy, JSONPatchRequestMove, JSONPatchRequestRemove, JSONPatchRequestReplace, JSONPatchRequestTst. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PatchRequestInner with oneOf schemas: JSONPatchRequestAdd, JSONPatchRequestCopy, JSONPatchRequestMove, JSONPatchRequestRemove, JSONPatchRequestReplace, JSONPatchRequestTst. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


