# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, field_validator
from pydantic import Field
from typing_extensions import Annotated
from antimatter.client.models.capability import Capability
from antimatter.client.models.domain_identity_principal_details import DomainIdentityPrincipalDetails
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PrincipalInfo(BaseModel):
    """
    Detailed information about a principal
    """ # noqa: E501
    principal_id: Annotated[str, Field(strict=True)] = Field(description="A unique identifier for a principal in an identity provider", alias="principalID")
    capabilities: List[Capability]
    details: DomainIdentityPrincipalDetails
    __properties: ClassVar[List[str]] = ["principalID", "capabilities", "details"]

    @field_validator('principal_id')
    def principal_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^pr-[123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz]{11}$", value):
            raise ValueError(r"must validate the regular expression /^pr-[123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz]{11}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PrincipalInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in capabilities (list)
        _items = []
        if self.capabilities:
            for _item in self.capabilities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['capabilities'] = _items
        # override the default output from pydantic by calling `to_dict()` of details
        if self.details:
            _dict['details'] = self.details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PrincipalInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "principalID": obj.get("principalID"),
            "capabilities": [Capability.from_dict(_item) for _item in obj.get("capabilities")] if obj.get("capabilities") is not None else None,
            "details": DomainIdentityPrincipalDetails.from_dict(obj.get("details")) if obj.get("details") is not None else None
        })
        return _obj


