# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from antimatter.client.models.read_context_rule_facts_inner_arguments_inner import ReadContextRuleFactsInnerArgumentsInner
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ReadContextRuleFactsInner(BaseModel):
    """
    ReadContextRuleFactsInner
    """ # noqa: E501
    operator: Optional[StrictStr] = Field(default=None, description="whether this assertion matches when the fact exists or does not exist")
    name: Optional[StrictStr] = Field(default=None, description="the name of the fact")
    arguments: Optional[List[ReadContextRuleFactsInnerArgumentsInner]] = None
    __properties: ClassVar[List[str]] = ["operator", "name", "arguments"]

    @field_validator('operator')
    def operator_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Exists', 'NotExists'):
            raise ValueError("must be one of enum values ('Exists', 'NotExists')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ReadContextRuleFactsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in arguments (list)
        _items = []
        if self.arguments:
            for _item in self.arguments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['arguments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ReadContextRuleFactsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "operator": obj.get("operator"),
            "name": obj.get("name"),
            "arguments": [ReadContextRuleFactsInnerArgumentsInner.from_dict(_item) for _item in obj.get("arguments")] if obj.get("arguments") is not None else None
        })
        return _obj


