# coding: utf-8

"""
    Antimatter Public API

    This API lets you interact with Antimatter Domains and Capsules

    The version of the OpenAPI document: 1.0.0
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ReadContextRuleMatchExpressionsInner(BaseModel):
    """
    ReadContextRuleMatchExpressionsInner
    """ # noqa: E501
    source: StrictStr
    key: StrictStr
    operator: StrictStr = Field(description="What to do with the value identified by `key`. In and NotIn compare with `values`, DateDeltaLessThan and DateDeltaGreaterThan treat the value as an RFC3339 date, and measure if the `now()-date` is less than or greater than the time span expressed in `value`. ")
    values: Optional[List[StrictStr]] = Field(default=None, description="to be used with In and NotIn operators")
    value: Optional[StrictStr] = Field(default=None, description="To be used with DateDelta operators. A time span in `23d4h5m32s` notation. It does not support interval shorthands greater than a day, so to express 3 months, for example, use `90d`. Positive time spans indicate the date appeared in the past. Negative time spans indicate the date appears in the future. ")
    __properties: ClassVar[List[str]] = ["source", "key", "operator", "values", "value"]

    @field_validator('source')
    def source_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('domainIdentity', 'readParameters', 'tags'):
            raise ValueError("must be one of enum values ('domainIdentity', 'readParameters', 'tags')")
        return value

    @field_validator('operator')
    def operator_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('In', 'NotIn', 'Exists', 'NotExists', 'DateDeltaLessThan', 'DateDeltaGreaterThan'):
            raise ValueError("must be one of enum values ('In', 'NotIn', 'Exists', 'NotExists', 'DateDeltaLessThan', 'DateDeltaGreaterThan')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ReadContextRuleMatchExpressionsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ReadContextRuleMatchExpressionsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "source": obj.get("source"),
            "key": obj.get("key"),
            "operator": obj.get("operator"),
            "values": obj.get("values"),
            "value": obj.get("value")
        })
        return _obj


